{$R+,S+}
Program urschr1; uses dos;
{dl`a dvizh. chastitsy v 1-mer. U(x) nakh. kolebat. spektr (energii urovnej,
  perekhody i int-sti) cherez raznostn. skhemu.
  2-ja proizv. ~= (x[i-1]-2*x[i]+x[i+1])/(2*delta_x); eto svodit ur. Schroed.
  na setke k matrichnomu s trekhdiag. matr. 
  3 primera: garm. osts. (HCl); osts. Morze (snova HCl); 2-jamn. (NH3).
}
{1-mer. angarm. osts.; m, r i U(r) zad. v SGSE;
  otsen. ili zad. k0; cherez nikh nakh. x0 i E0 i preobr. r_i i U_r
  k bezrazm. vidu; nakhodim spektr; vozvr. k energijam (perevod`a v sm-1);
  dodelan schot intens-stej perekhodov i spektra pri zadann. T.
}
{H*psi = -(h_^2/2m)*(d2_psi/dx2) + U(x)*psi = E*psi ;
  ksi=x/x0; x=x0*ksi;
  dl`a ostsil. izv. k i m; vv. x0:
  x0 = sqrt(h_/sqrt(km)); x0^2=h_/sqrt(km); 1/x0^2=sqrt(km)/h_ .
  H*psi = (h_^2/2m)*(1/x0^2)*(d2_psi/dx2) + U(x(ksi))*psi = E*psi .
  Osts-r: 1-j chlen + (k/2)*xo^2*ksi^2*psi = E*psi .
  Delim vse chleny na h_*sqrt(k/m) ->
  -(1/2)*(d2_psi/d_ksi_2) + (1/2)*ksi^2*psi = (E/(E0))*psi
  (gde E0=h_*omega0, a ne E(v=0)=0.5*E0).
  V obshch. sluchae:
  -(1/2)*(d2_psi/d_ksi_2) + (U(r)/E0)*psi = (E/(E0))*psi .
  Vs`o stalo bezrazmern.
  Jeshcho raz - koroche:
  (-h_^2/2m)*(d2_psi/dx2) + U(x)*psi = E*psi ; U(x)=(k/2)*x^2;
  x=x0*ksi; d2/dx^2 = (1/x0^2)*d2/d_ksi^2;
  ber`om x0=sqrt(h_/sqrt(k*m)); 1/x0^2=sqrt(km)/h_ = omega*m/h_ .
  -(h_^2/2m)*(omega*m/h_)*d2_psi/d_ksi^2 + U(ksi)*psi = E*psi;
                 U(ksi) = (m*omega^2/2)*(h_/(omega*m))*ksi^2 .
  Privodim mnozhiteli ->
  (-h_*omega/2)*d2_psi/d_ksi^2 + U(ksi)*psi = E*psi;
                 U(ksi) = (-h_*omega/2)*ksi^2*psi.
  Delim vs`o na h_*omega -> chto vyshe.
}
{2-ja proizv. ~= (x[i-1]-2*x[i]+x[i+1])/(delta_x^2); eto svodit ur. Schroed.
  na setke k matrichnomu s trekhdiag. matr. Primer: garm. osts.}

{ ------------------------- }
 {$i uses_gra.pas}
 {$i constant.pas}
 const n_max=101;
 type matr=array[1..n_max,1..n_max] of real;
 type vect=array[1..n_max] of real;
 {$i imtql2.pas}

 var h,hh:vect; sv:matr; npont,nprom,i,j,kk:integer; x_i,U_x:vect;
 var m,ee,de:real;
 var del,del2,r:real;
 var e1,e2,e3:ekr;
 var kT,ny,intens_,exp_E_kT,intens:real;
 var x0_,x1_,x:real;
 var x0_e,x1_e,y0_e,y1_e:real; nx,ny_:integer;
 var Emax,arg:real; n_Emax:integer;
(*
 { --------------------- }
 {molek. HCl - garm. pribl.; sm. MORZE.PAS - Krasnov K.S., Molek. i
   khim. sv`az`, s.276}
 var k,r0_:real;
 procedure U_init; var x0,E0:real;
 begin
  m:=1.62700E-24 {prived. massa v g}; k:=5.16426E+05; r0_:=1.2745*angst;
  x0_:=r0_-0.5*angst; x1_:=r0_+0.5*angst;
  x0_e:=0*angst; x1_e:=3*angst; y0_e:=0; y1_e:=20000; nx:=6; ny_:=20;
  Emax:=15000.0; n_Emax:=15;
  x0:=sqrt(hx/sqrt(k*m)); E0:=hx*sqrt(k/m);
  writeln('x0,E0=',x0/angst:10:4,E0/k_erg*k_smm1:10:4);
  writeln('ENTER dl`a prodolzh.:'); readln;
 end;
 function U(x:real):real;
 begin
  U:=(k/2)*sqr(x-r0_);
 end;
 { -------------------- }
*)
(*
 { -------------------- }
 {molek. HCl - pot. kriv. Morze; sm. MORZE.PAS - Krasnov K.S., Molek. i
   khim. sv`az`, s.276}
 var A,al,r0_:real;
 procedure U_init;
 begin
  m:=1.62700E-24 {prived. massa v g}; {k:=5.16426E+05;} r0_:=1.2745*angst;
  A:=7.09770E-12; al:=1.90735E+08; {1/al=5.24288E-09}
  x0_:=r0_-0.3*angst; x1_:=r0_+0.7*angst;
  x0_e:=0*angst; x1_e:=3*angst;
  y0_e:=-A/k_erg*k_smm1; y1_e:=y0_e+20000;
  nx:=6; ny_:=20;
  Emax:=15000.0; n_Emax:=15;
 end;
 function U(r:real):real; var x:real; var aa,bb,cc:real;
 begin
  x:=r-r0_; U:=A*(exp(-2*al*x)-2*exp(-al*x));
 end;
 { -------------------- }
*)

 { -------------------- }
 {NH3 - inversija; Tauns, Shavlov, s.273-277.}
 procedure U_init;
 begin
  {m:=(3*14/(3+14))*aem;} m:=3.0*aem;
  x0_:=-0.8*angst; x1_:=0.8*angst;
  x0_e:=-2*angst; x1_e:=2*angst; y0_e:=-46000.0; y1_e:=-40000.0;
  nx:=4; ny_:=6;
  Emax:=4000.0; n_Emax:=4;
 end;
 function U(x:real):real; var ro,a,b,c,sec2:real;
 begin
  ro:=6.98e-9/sqrt(3*1.008);
  a:=x/(2*ro); b:=(exp(a)+exp(-a))/2; sec2:=1/sqr(b);
  c:=66551.0*sqr(sec2)-109619.0*sec2; U:=c*k_erg/k_smm1;
 end;
 { ------------------- }


Begin writeln; initmnozh;
 U_init; {U_init zad. tzh. predely, v k-rykh ishchutsa VF, i predely ekrana}
 initgraph_12;
 prisv_ekr(e1, 0,x_y/2,0.5,1, x0_e,x1_e,y0_e,y1_e,y0_e,y1_e,y0_e,y1_e);
 prisv_ramk(e1,nx,ny_,1,1); ramka(e1);
 { ---------------- }
 {izobr. potentsial}
 for i:=0 to 600 do begin
  {writeln('x0_,x1_=',x0_:16,' ',x1_:16);}
  x:=x0_+(i/600)*(x1_-x0_);
  {writeln('Gol. prog.: x (A) =',x/angst:10:4);}
  ee:=U(x)/k_erg*k_smm1; po(x,ee,e1,12);
 end;
 { ---------------- }
 {izobr., kakie tochki potentsiala vz`aty dl`a postr. setki}
 npont:={100}60; nprom:=npont-1;
 del:=(x1_-x0_)/nprom; del2:=sqr(del);
 for i:=1 to npont do begin
  x_i[i]:=x0_+(i-1)*del;
  U_x[i]:=U(x_i[i]);
  po((x_i[i]),U_x[i]/k_erg*k_smm1,e1,15);
 end;
 { ----------------- }
 for i:=1 to npont do for j:=1 to npont do begin h[i]:=0; hh[i]:=0; end;
 for i:=1 to npont do begin
  h[i]:=(-1/2)*((hx/m)*hx)*(-2/del2) + U_x[i];
  if i<npont then begin
   hh[i]:=(-1/2)*((hx/m)*hx)*(1/del2);
  end;
 end;
 {
 for i:=1 to npont do write(h[i]/k_erg*k_smm1:10:2); writeln;
 for i:=1 to (npont-1) do write(hh[i]/k_erg*k_smm1:10:2); writeln;
 }
 { ----------------------------- }
 imtql2(h,hh,sv,npont,1e-6);
 { ----------------------------- }
 {izobr. voln. f-tsij}
 de:=(e1.y1-e1.y0)/10;
 for i:=1 to npont do begin
  ee:=h[i]/k_erg*k_smm1;
  {if ee<1e6 then write(ee:10:2) else write(' ******.**');}
  if ee<e1.y1 then begin
   l(x_i[1],ee,x_i[npont],ee,e1,9);
   for j:=1 to npont-1 do begin
    l(x_i[j],ee+de*sv[j,i],x_i[j+1],ee+de*sv[j+1,i],e1,7);
    po(x_i[j],ee+de*sv[j,i],e1,15);
   end;
  end;
 end; {writeln;}
 { ----------------------------- }
 {rasschot sp-ra pogloshch.}
 for i:=1 to 15 do writeln;
 prisv_ekr(e2, x_y/2,x_y,0.5,1, 0,Emax,y0_e,y1_e,y0_e,y1_e,y0_e,y1_e);
 prisv_ramk(e2,n_Emax,ny_,1,1); ramka(e2);
 prisv_ekr(e3, x_y/2,x_y,0,0.5, e2.x0,e2.x1,0,1,0,1,0,1);
 prisv_ramk(e3,n_Emax,10,1,1); ramka(e3);
 for i:=1 to npont do if h[i]/k_erg*k_smm1<=e2.y1 then
   l(0,h[i]/k_erg*k_smm1,e2.x1,h[i]/k_erg*k_smm1,e2,9);
 kT:=200;
 for i:=1 to npont do begin
  arg:=-((h[i]-h[1])/k_erg*k_smm1)/kT;
  if arg>-80 then begin
   exp_E_kT:=exp(arg);
   for j:=i+1 to npont do begin
    ny:=(h[j]-h[i]); ny:=ny/k_erg*k_smm1;
    intens_:=0;
    for kk:=1 to npont do intens_:=intens_+sv[kk,i]*sv[kk,j]*x_i[kk];
    intens_:=sqr(intens_);
    {Sum c_i^2=1; Int psi^2 dx =1; => psi_i = c_i/sqrt(dx);
      Int psi0 psi1 x dx = (dx sokrashch.) Sum c0 c1 x =
      Sum c1 c0 (x/x0) x0; c0*(x/x0) ~ c1, kogda x0 - kharakt. razmer. psi0-no;
      => Int ~ x0 ~ 0,1A ~ 10^-9 cm; Int^2 ~ 10^-18 cm^2.
      Prakticheski: Int psi0 psi1 x dx = Sum c0 c1 x; dejstvit. ~0,5*10^-18;
      chtoby masshtab byl udobnee, *10^18.
    }
    intens_:=1E18*intens_; intens:=intens_*exp_E_kT;
    {write(i:5,j:5,' ',ny:10:4,intens_:10:4,' ',exp_E_kT:14,' ',intens:10:4);
      readln;}
    if intens>0.001 then begin
     writeln(i:3,j:3,h[i]/k_erg*k_smm1:10:2,ny:10:2,intens:8:4);
     l(ny,h[i]/k_erg*k_smm1,ny,h[j]/k_erg*k_smm1,e2,15);
     l(ny,0,ny,intens,e3,15);
    end;
   end {j};
  end {if arg}
 end {i};
 { --------------------------- }
 readln; closegraph;
End.
